#!/usr/bin/env ruby

require 'pp'
require "base64"
require 'net/http'
require 'net/https'
require 'uri'
require 'xmlrpc/client'
require 'digest/md5'

SERVER = '192.168.100.179'
PORT = 4443
USER = 'server'
PASS = 'serverp'
FILENAME = 'file.pdf'

BOUNDARY = "WebKitFormBoundaryALoRruby" 
def encode_multipartformdata(parameters = {}) 
  ret = String.new 
  parameters.each do |key, value| 
    unless value.empty? 
      ret << "\r\n--" << BOUNDARY << "\r\n" 
      ret << "Content-Disposition: form-data; name=\"#{key}\"; filename=\"" << FILENAME << "\"\r\n" 
      ret << "Content-Type: application/octet-stream\r\n\r\n"
      ret << value 
    end 
  end 
  ret << "\r\n--" << BOUNDARY << "--\r\n" 
end


def upload_fake_file(cookie)
  Net::HTTP.version_1_2
  http = Net::HTTP.new(SERVER, PORT)
  http.use_ssl = true

  headers = {
    'Cookie' => cookie,
    'Content-Type' => 'multipart/form-data; boundary=' << BOUNDARY,
    'User-Agent' => 'ruby 1.8.6',
    'Expect' => '100-continue'
  }

  f = File.open(FILENAME, 'rb').read

  data = {'file' => f}
  data_enc = encode_multipartformdata(data)

  resp = http.request_post('/upload.php', data_enc, headers)
  
  return resp.body
end


  server = XMLRPC::Client.new(SERVER, "/server.php", PORT, nil, nil, nil, nil, true)

  puts "LOGIN..."
  server.call("auth.login", USER, PASS)
    
  content = upload_fake_file(server.cookie)
  
  pp content
  
  puts "LOGOUT..."
  server.call("auth.logout")


